#region Copyright
/*
 * Copyright 2005-2009 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
#endregion

using System;

namespace Seasar.Dxo.Annotation
{
    /// <summary>
    /// DataExchange(DxO)ɑ΂āÃvpeBɑ΂ϊ@LqJX^
    /// </summary>
    /// <seealso cref="Attribute"/>
    [AttributeUsage(AttributeTargets.Method, Inherited = true, AllowMultiple = true)]
    public sealed class ConversionRuleAttribute : Attribute
    {
        private string _propertyName;
        private string _targetPropertyName;
        private Type _propertyConverter;
        private bool _ignore;

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="propertyName">ϊJX^}CYvpeB</param>
        /// <param name="targetPropertyName">ϊƂȂvpeB(ȗAϊPropertyNameƓ)</param>
        /// <param name="propertyConverter">Ώۂ̃vpeBϊ邽߂̃Ro[^̌^</param>
        /// <param name="ignore">^ϊsȂƂwtO</param>
        public ConversionRuleAttribute(string propertyName, string targetPropertyName, Type propertyConverter, bool ignore)
        {
            this._propertyName = propertyName;
            if (!string.IsNullOrEmpty(targetPropertyName))
                this._targetPropertyName = targetPropertyName;
            else
                this._targetPropertyName = propertyName;
            this._propertyConverter = propertyConverter;
            this._ignore = ignore;
        }

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="propertyName">ϊJX^}CYvpeB</param>
        /// <param name="targetPropertyName">ϊƂȂvpeB(ȗAϊPropertyNameƓ)</param>
        /// <param name="propertyConverter">Ώۂ̃vpeBϊ邽߂̃Ro[^̌^</param>
        public ConversionRuleAttribute(string propertyName, string targetPropertyName, Type propertyConverter)
        {
            this._propertyName = propertyName;
            if (!String.IsNullOrEmpty(targetPropertyName))
                this._targetPropertyName = targetPropertyName;
            else
                this._targetPropertyName = propertyName;
            this._propertyConverter = propertyConverter;
            this._ignore = false;
        }

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="propertyName">ϊJX^}CYvpeB</param>
        /// <param name="targetPropertyName">ϊƂȂvpeB(ȗAϊPropertyNameƓ)</param>
        public ConversionRuleAttribute(string propertyName, string targetPropertyName)
        {
            this._propertyName = propertyName;
            if (!String.IsNullOrEmpty(targetPropertyName))
                this._targetPropertyName = targetPropertyName;
            else
                this._targetPropertyName = propertyName;
            _propertyConverter = null;
            _ignore = false;
        }

        /// <summary>
        /// RXgN^
        /// </summary>
        public ConversionRuleAttribute()
        {
            this._propertyName = String.Empty;
            this._targetPropertyName = String.Empty;
            this._propertyConverter = null;
            this._ignore = false;
        }

        /// <summary>
        /// ϊJX^}CYvpeB
        /// </summary>
        public string PropertyName
        {
            get { return _propertyName; }
            set { _propertyName = value; }
        }

        /// <summary>
        /// ϊƂȂvpeB
        /// (ȗꍇAϊPropertyNameƓƂ݂Ȃ܂)
        /// </summary>
        public string TargetPropertyName
        {
            get { return _targetPropertyName; }
            set { _targetPropertyName = value; }
        }

        /// <summary>
        /// Ώۂ̃vpeBϊ邽߂̃Ro[^̌^
        /// (̌^̃ftHgRXgN^ŁARo[^̃CX^X𐶐邱Ƃ
        /// łȂĂ͂Ȃ܂)
        /// </summary>
        public Type PropertyConverter
        {
            get { return _propertyConverter; }
            set { _propertyConverter = value; }
        }

        /// <summary>
        /// vpeBƋɎw肷邱ƂŁA^ϊsȂƂwtO
        /// </summary>
        public bool Ignore
        {
            get { return _ignore; }
            set { _ignore = value; }
        }
    }
}