#region Copyright
/*
 * Copyright 2005-2009 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
#endregion

using System;
using System.Diagnostics;

namespace Seasar.Dxo.Converter
{
    /// <summary>
    /// f𑊌ݕϊ邽߂̃Ro[^ۃNX
    /// </summary>
    public abstract class AbstractPropertyConverter : IPropertyConverter
    {
        private string _formatString;

        public string Format
        {
            get { return _formatString; }
            set { _formatString = value; }
        }

        /// <summary>
        /// vpeB̃Ro[gOɔCxg
        /// </summary>
        public event EventHandler<ConvertEventArgs> PrepareConvert;

        /// <summary>
        /// Ro[gۂɔCxg
        /// </summary>
        public event EventHandler<ConvertEventArgs> ConvertCompleted;

        /// <summary>
        /// Ro[gsۂɔCxg
        /// </summary>
        public event EventHandler<ConvertEventArgs> ConvertFail;

        /// <summary>
        /// IuWFNg̃vpeBCӂ̌^ɕϊ܂
        /// </summary>
        /// <param name="propertyName">vpeB</param>
        /// <param name="source">ϊ̃IuWFNg</param>
        /// <param name="dest">ϊ̃IuWFNg</param>
        /// <param name="expectType">ϊ̃IuWFNgɊ҂Ă^</param>
        public void Convert(string propertyName, object source, ref object dest, Type expectType)
        {
            if (PrepareConvert != null)
            {
                PrepareConvert(this, new ConvertEventArgs(propertyName, source, ref dest, expectType));
            }

            if (this.DoConvert(source, ref dest, expectType))
            {
                //Ro[g
                if (ConvertCompleted != null)
                {
                    ConvertCompleted(this, new ConvertEventArgs(propertyName, source, ref dest, expectType));
                }
            }
            else
            {
                Debug.WriteLine("### Property Conversion fail!");
                Debug.WriteLine("         property PropertyConverter:" + this.GetType().Name);
                Debug.WriteLine("         property Name     :" + propertyName);
                Debug.WriteLine("             source Type   :" + ((source != null)
                                                                      ? source.GetType().Name
                                                                      : "null"));
                Debug.WriteLine("             source Value  :" + ((source != null)
                                                                      ? source.ToString()
                                                                      : "null"));
                Debug.WriteLine("            expected Type  :" + expectType.Name);
                //Ro[gs
                if (ConvertFail != null)
                {
                    ConvertFail(this, new ConvertEventArgs(propertyName, source, ref dest, expectType));
                }
            }
        }


        /// <summary>
        /// IuWFNg̃vpeBCӂ̌^ɕϊ܂
        /// (ۃ\bh͔hNXŕKI[oCh܂)
        /// </summary>
        /// <param name="source">ϊ̃IuWFNg</param>
        /// <param name="dest">ϊ̃IuWFNg</param>
        /// <param name="expectType">ϊ̃IuWFNgɊ҂Ă^</param>
        /// <returns>bool ϊꍇɂtrue</returns>
        protected abstract bool DoConvert(object source, ref object  dest, Type expectType);
    }
}