#region Copyright
/*
 * Copyright 2005-2009 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
#endregion

using System;
using Seasar.Quill.Util;

namespace Seasar.Quill.Exception
{
    /// <summary>
    /// QuillŃAvP[VG[ꍇɃX[ONX
    /// </summary>
    [Serializable]
    public class QuillApplicationException : ApplicationException
    {
        /// <summary>
        /// bZ[WR[h
        /// </summary>
        protected string messageCode;

        /// <summary>
        /// bZ[Wɖߍޒl̔z
        /// </summary>
        protected object[] args;

        /// <summary>
        /// bZ[W(bZ[WR[h܂)
        /// </summary>
        protected string message;

        /// <summary>
        /// ȒPȃbZ[W(bZ[WR[h܂܂Ȃ)
        /// </summary>
        protected string simpleMessage;

        /// <summary>
        /// bZ[WR[hw肵QuillApplicationException
        /// </summary>
        /// <param name="messageCode">bZ[WR[h</param>
        public QuillApplicationException(string messageCode)
            : this(messageCode, null, null)
        {
        }

        /// <summary>
        /// bZ[WR[hƃbZ[Ww肵QuillApplicationException
        /// </summary>
        /// <param name="messageCode">bZ[WR[h</param>
        /// <param name="message">bZ[W</param>
        public QuillApplicationException(string messageCode, string message)
        {
            // bZ[WZbg
            simpleMessage = message;

            // bZ[WR[ht̃bZ[WZbg
            this.message = "[" + messageCode + "]" + simpleMessage;
        }

        /// <summary>
        /// bZ[WR[hEbZ[Wɖߍޕ̔zw肵
        /// QuillApplicationException
        /// </summary>
        /// <param name="messageCode">bZ[WR[h</param>
        /// <param name="args">bZ[Wɖߍޕ̔z</param>
        public QuillApplicationException(string messageCode, object[] args)
            : this(messageCode, args, null)
        {
        }

        /// <summary>
        /// bZ[WR[hEbZ[Wɖߍޕ̔zEƂȂO
        /// w肵QuillApplicationException
        /// </summary>
        /// <param name="messageCode">bZ[WR[h</param>
        /// <param name="args">bZ[Wɖߍޒl̔z</param>
        /// <param name="cause">ƂȂO</param>
        public QuillApplicationException(
            string messageCode, object[] args, System.Exception cause)
            : base(null, cause)
        {
            // bZ[WR[hZbg
            this.messageCode = messageCode;

            // bZ[Wɖߍޒl̔zZbg
            this.args = args;

            // bZ[WZbg
            simpleMessage = MessageUtil.GetSimpleMessage(messageCode, args);

            // bZ[WR[ht̃bZ[WZbg
            message = "[" + messageCode + "]" + simpleMessage;
        }

        /// <summary>
        /// bZ[WR[h擾
        /// </summary>
        /// <value>bZ[WR[h</value>
        public string MessageCode
        {
            get { return messageCode; }
        }

        /// <summary>
        /// bZ[Wɖߍޒl̔z擾
        /// </summary>
        /// <value>bZ[Wɖߍޒl̔z</value>
        public object[] Args
        {
            get { return args; }
        }

        /// <summary>
        /// bZ[W(bZ[WR[h܂)擾Eݒ肷
        /// </summary>
        /// <value>bZ[W(bZ[WR[h܂)</value>
        public override string Message
        {
            get { return message; }
        }

        /// <summary>
        /// ȒPȃbZ[W(bZ[WR[h܂܂Ȃ)擾
        /// </summary>
        /// <value>ȒPȃbZ[W(bZ[WR[h܂܂Ȃ)</value>
        public string SimpleMessage
        {
            get { return simpleMessage; }
        }
    }
}
