#region Copyright
/*
 * Copyright 2005-2009 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
#endregion

using System;

namespace Seasar.Framework.Container.AutoRegister
{
    /// <summary>
    /// R|[lgɎIɖOtׂ̕W̃NXłB
    /// </summary>
    public class DefaultAutoNaming : IAutoNaming
    {
        #region IAutoNaming o

        /// <summary>
        /// R|[lg`܂B
        /// </summary>
        /// <remarks>
        /// <para>C^[tF[X̏ꍇ̓vtBbNX"I"菜
        /// C^[tF[XiOԂ͊܂܂ȂjR|[lgƂ܂B
        /// i2ڂ啶̏ꍇ̂1ڂvtBbNXƔf܂j</para>
        /// <para>ȊO͖OԂ܂܂ȂȈՖR|[lgƂ܂B</para>
        /// </remarks>
        /// <param name="type">R|[lg`Type</param>
        /// <returns>R|[lg</returns>
        public string DefineName(Type type)
        {
            string name;

            if (type.IsInterface && type.Name.Length > 1 && type.Name[0] == 'I'
                && char.IsUpper(type.Name[1]))
            {
                // C^[tF[X̃vtBbNXƔfꍇ
                // vtBbNX"I"̂R|[lgƂ
                name = type.Name.Substring(1);
            }
            else
            {
                // LȊȌꍇ͊ȈՖR|[lgƂ
                name = type.Name;
            }

            return name;
        }

        #endregion
    }
}
